<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */
  
namespace FiloBlu\OrderAdditionalData\Setup; 
 
use Magento\Framework\Setup\UpgradeSchemaInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use Magento\Framework\Setup\SchemaSetupInterface;
use Magento\Framework\DB\Ddl\Table;
 
class UpgradeSchema implements UpgradeSchemaInterface
{
    protected $_statusFactory;
    public function __construct(
        \Magento\Sales\Model\Order\StatusFactory $statusFactory
    ){
        $this->_statusFactory = $statusFactory;
    }
    public function upgrade(SchemaSetupInterface $setup, ModuleContextInterface $context)
    {
        $installer = $setup;
        $installer->startSetup();
        if (version_compare($context->getVersion(), '1.0.5') < 0) {

            // Get module table
            $connection = $installer->getConnection();
            
            $orderTable = $installer->getTable('sales_order');            
            if ($setup->getConnection()->isTableExists($orderTable) == true) {
                // Declare data
                $connection->addColumn( 
                    $orderTable,
                    'fbnetsuite_base_theoric_shipping_amount', 
                    [
                        'type' => \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                        'length' => '12,4',
                        'default' => 0,
                        'nullable' => false,
                        'comment' => 'Base Theoric Shipping Amount (Free Shipping)',
                    ]
                );
                $connection->addColumn(
                    $orderTable,
                    'fbnetsuite_theoric_shipping_amount',                    
                    [
                        'type' => \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                        'length' => '12,4',
                        'default' => 0,
                        'nullable' => false,
                        'comment' => 'Theoric Shipping Amount (Free Shipping)'
                    ]
                );
            }
            $itemTable = $installer->getTable('sales_order_item');            
            if ($setup->getConnection()->isTableExists($itemTable) == true) {
                // Declare data
                $connection->addColumn( 
                    $itemTable,
                    'kpi_full_price', 
                    [
                        'type' => \Magento\Framework\DB\Ddl\Table::TYPE_DECIMAL,
                        'length' => '12,4',
                        'default' => 0,
                        'nullable' => false,
                        'comment' => 'Product Full Price',
                    ]
                );

            }            
        }
    
        $installer->endSetup();
    }
}